SystemOrganization addCategory: #AppleScriptProgrammer!

Object subclass: #OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter
	instanceVariableNames: 'appleScriptStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 6/16/2009 17:51'!
appleScriptStream

	^appleScriptStream setDefault: #defaultAppleScriptStream for: self withSetter: #appleScriptStream:! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 6/16/2009 17:51'!
appleScriptStream: anObject
		
	appleScriptStream := anObject! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2011 12:54'!
appleScriptVariableNameForClass: aClass

	^'St', aClass name! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'defaults' stamp: 'hjo 6/16/2009 17:51'!
defaultAppleScriptStream

	^FileStream newFileNamed: 'oo.scpt'! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2011 13:01'!
writeAllClassesToFileUnder: rootClass
	| stream dependencySorter |
	self appleScriptStream
		nextPutAll:
			'tell application "OmniOutliner"
	
	tell (make new document)
		set St' , rootClass name , ' to make new row with properties {topic:"', rootClass name ,'"} at end
'.
	stream := self appleScriptStream.
	dependencySorter := SuperClassDependencySorter new.
	dependencySorter commitInsert: rootClass.
	(rootClass allSubclasses) do: [ :eachClass | dependencySorter insert: eachClass ].
	(dependencySorter sortedCollection copyWithout: rootClass)
		do: [ :each | 
			stream tab.
			stream tab.
			stream nextPutAll: 'set St'.
			stream nextPutAll: each name.
			stream nextPutAll: ' to make new row with properties {topic:"'.
			stream nextPutAll: each name.
			stream nextPutAll: '"} at end of children of '.
			stream
				nextPutAll:
					(each superclass isNil
						ifTrue: [ 'St' , rootClass name ]
						ifFalse: [ 'St' , each superclass name ]).
			stream cr ].
	self appleScriptStream
		nextPutAll:
			'	end tell
end tell'.
	self appleScriptStream close! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2011 12:52'!
writeAllClassesToFileUnderProtoObject

	self writeAllClassesToFileUnder: ProtoObject.! !
